* preliminaries, variables, exit
        include         "92plus.h"
        include         "util.h"
      xdef       _main
     xdef       _comment
_main:
        move.w          #1,-(a7)
        jsr        tios::FontSetSys
        addq.l          #2,a7
        move.w          d0,oldfont
        bsr             fillscreen
        move.w          oldfont,-(a7)
        jsr        tios::FontSetSys
        addq.l          #2,a7
        rts
oldfont:        dc.w    0
realstart:      dc.l    disass
stadr:          dc.l    $412188
aktadr:         dc.l    $412188
withspaces:     dc.l    0
whatmode:       dc.w    1               ;1:disass, 0:hexed
adrstr:         dc.b    "$123456:"
buffer:		ds.b	128
copyright:      dc.b    "TI92plus Disassembler, Monitor 1.00",0
copyright2:     dc.b    "by A.K. 1990,91,98,99",0
copyright3:     dc.b    "Hit any key...",0
addrinstr:      dc.b    "key in new startaddress:   ",0
addrinstr2:     dc.b    "$      ",0

        even
main:   jsr             util::idle_loop
        cmp.w		#109,d0
	bne		\nomodchg
        eori.w          #1,whatmode              ;umschalten disass,hexed
	bra		fillscreen
\nomodchg:
	cmp.w           #344,d0                 ;Cursordown: plus 2 Bytes
        bne             \notpltwo
        add.l           #2,stadr
        bra             fillscreen
\notpltwo:
        cmp.w           #338,d0                 ;Cursorup: minus 2 Bytes
        bne             \notmitwo
        sub.l           #2,stadr
        bra             fillscreen
\notmitwo:
        cmp.w           #264,d0                 ;Esc
        bne             \noexit
        rts
\noexit:
        cmp.w           #13,d0                  ;Enter: next page
        bne             \noenter
        move.l          aktadr,stadr
        bra             fillscreen
\noenter:
        cmp.w           #114,d0                 ;r: to last keyed in address
        bne             \notrealput
        move.l          realstart,stadr
        bra             fillscreen
\notrealput:
        cmp.w           #99,d0                  ;c: print copyright
        bne             \notcpyrgt
        bsr             putcopyr
        move.w          #4,-(a7)
        pea             copyright3
        move.w          #105,-(a7)
        move.w          #140,-(a7)
        jsr        tios::DrawStrXY
        lea             10(a7),a7

        jsr        util::idle_loop
        bra             fillscreen
\notcpyrgt:
        cmp.w           #275,d0                 ;F8: new address
        beq             newaddress
        cmp.w           #273,d0                 ;F1-F5: +10h..+100000h Bytes
        bcc             \do_up
        sub.w           #268,d0
        bsr             makechg
        add.l           d1,stadr
        and.l           #$ffffff,stadr
        bra             fillscreen
\do_up: sub.w           #8460,d0               ;diamond F1..F5: -10h..-100000h Bytes
        bmi             main
        cmp.w           #6,d0
        bcc             main
        bsr             makechg
        sub.l           d1,stadr
        and.l           #$ffffff,stadr
        bra             fillscreen
makechg:
        move.l          #1,d1                   ;erzeuge $10^(d0+1)
\mulit: asl.l           #4,d1
        dbra            d0,\mulit
        rts
putcopyr:
        jsr         util::zap_screen
        move.w          #4,-(a7)
        pea             copyright
        move.w          #20,-(a7)
        move.w          #14,-(a7)
        jsr        tios::DrawStrXY
        lea             8(a7),a7
        pea             copyright2
        move.w          #35,-(a7)
        move.w          #44,-(a7)
        jsr        tios::DrawStrXY
        lea             10(a7),a7
        rts
clradbuf:
        move.l          #$24202020,(a4)
        move.w          #$2020,4(a4)
        move.b          #$20,6(a4)
        rts

newaddress:
        bsr            putcopyr
        move.w         #4,-(sp)
        pea            addrinstr
        move.w         #105,-(a7)
        move.w         #34,-(a7)
        jsr       tios::DrawStrXY
        lea            10(a7),a7
        clr.l          d7
        move.w         #1,d6
\false: jsr       util::idle_loop
        cmp.b          #264,d0
        beq            fillscreen
        cmp.b          #13,d0
        beq             \readyad
        cmp.b           #'0',d0
        bcs             \false
        cmp.b           #'g',d0
        bcc             \false
        cmp.b           #'9',d0
        bls             \is09
        cmp.b           #'a',d0
        bcs             \false
        sub.b           #('a'-10),d0
        bra             \readydig
\is09:  sub.s           #'0',d0
\readydig:
        rol.l           #4,d7
        add.b           d0,d7
        movea.l         #addrinstr2,a4
        bsr             clradbuf
        move.l          d7,d1
        bsr             _hexlong
        move.w          #4,-(a7)
        pea             addrinstr2
        move.w          #105,-(a7)
        move.w          #182,-(a7)
        jsr        tios::DrawStrXY
        lea             10(a7),a7
        addq.l          #1,d6
        cmp.b           #7,d6
        bcs             \false
\readyad:
        cmp.l           #0,d7
        beq             newaddress
        lsr.l           #1,d7
        lsl.l           #1,d7
        move.l          d7,realstart
        move.l          d7,stadr
;        bra             fillscreen









fillscreen:
        jsr            util::zap_screen
        moveq           #0,d7
        move.l          stadr,a0
        move.l          a0,aktadr
\filllp:
        move.l          #0,withspaces
        movea.l		#adrstr,a4
        bsr             clradbuf
        move.b          #$3a,7(a4)
	move.l		aktadr,d1
	bsr		_hexlong	
        lea             buffer(pc),a1
	move.w		whatmode,d0
	cmp.w		#0,d0
	bne		\dodisa
	bsr		hexmoni
	bra		\nodisa
\dodisa:
       	bsr             disass
\nodisa:
	andi.l          #$0000ffff,d0
        add.l           d0,aktadr
        cmp.w           #1,whatmode
        bne             \readyhere
        move.b          #127,d0
\lp:    add.l           #1,a1
        move.b          (a1),d0
        cmp.b           #0,d0
        beq             \readyhere
        cmp.b           #9,d0
        bne             \lp
        move.b          #0,(a1)
        add.l           #1,a1
        move.l          a1,withspaces

\readyhere:
        move.w          #4,-(a7)
        move.l          #adrstr,a0
        addq.l          #1,a0
        move.l          a0,-(a7)
        move.w          d7,d0
        mulu            #9,d0
        move.w          d0,-(a7)
        move.w          #0,-(a7)
        jsr        tios::DrawStrXY
        addq.l          #2,a7
        move.w          (a7)+,d0
        addq.l          #6,a7
        move.l          withspaces,a0
        cmpa.l          #0,a0
        beq             \nothing
        move.w          #4,-(a7)
        move.l          withspaces,-(a7)
        move.w          d0,-(a7)
        move.w          #92,-(a7)
        jsr        tios::DrawStrXY
        lea             10(a7),a7
\nothing:
        movea.l         aktadr,a0
        addq.w          #1,d7
        cmp.w           #14,d7
        bcs             \filllp
        bra             main

hexmoni:
	movem.l		d1-d2/d7/a0-a2/a4,-(sp)
	move.l		a0,a2
	move.b		#' ',(a1)+
	lea		_hexdig(pc),a4
	moveq.w		#7,d7
\hloop1:
	move.b		(a0)+,d1
	move.b		d1,d2
	ror.b		#4,d2
	andi.w		#$f,d2
	move.b		0(a4,d2.w),(a1)+
	andi.w		#$f,d1
	move.b		0(a4,d1.w),(a1)+
	move.b		#' ',(a1)+
	dbf		d7,\hloop1
	moveq.w		#7,d7
\hloop2:
	move.b		(a2)+,d1
	cmp.b		#0,d1
	bne		\nopoint
        move.b          #'.',d1
\nopoint:
	move.b		d1,(a1)+
	dbf		d7,\hloop2
	move.b		#0,(a1)+
	movem.l		(sp)+,d1-d2/d7/a0-a2/a4
	moveq.w		#8,d0
	rts		



        include "reass.asm"


_comment        dc.b    "TI92plus disassembler by A.K.",0
       end
